<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDispatcherResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfDispatcherResult extends AbstractStructArrayBase
{
    /**
     * The DispatcherResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DispatcherResult[]
     */
    public $DispatcherResult;
    /**
     * Constructor method for ArrayOfDispatcherResult
     * @uses ArrayOfDispatcherResult::setDispatcherResult()
     * @param \StructType\DispatcherResult[] $dispatcherResult
     */
    public function __construct(array $dispatcherResult = array())
    {
        $this
            ->setDispatcherResult($dispatcherResult);
    }
    /**
     * Get DispatcherResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DispatcherResult[]|null
     */
    public function getDispatcherResult()
    {
        return isset($this->DispatcherResult) ? $this->DispatcherResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDispatcherResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDispatcherResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDispatcherResultForArrayConstraintsFromSetDispatcherResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDispatcherResultDispatcherResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfDispatcherResultDispatcherResultItem instanceof \StructType\DispatcherResult) {
                $invalidValues[] = is_object($arrayOfDispatcherResultDispatcherResultItem) ? get_class($arrayOfDispatcherResultDispatcherResultItem) : sprintf('%s(%s)', gettype($arrayOfDispatcherResultDispatcherResultItem), var_export($arrayOfDispatcherResultDispatcherResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DispatcherResult property can only contain items of type \StructType\DispatcherResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DispatcherResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DispatcherResult[] $dispatcherResult
     * @return \ArrayType\ArrayOfDispatcherResult
     */
    public function setDispatcherResult(array $dispatcherResult = array())
    {
        // validation for constraint: array
        if ('' !== ($dispatcherResultArrayErrorMessage = self::validateDispatcherResultForArrayConstraintsFromSetDispatcherResult($dispatcherResult))) {
            throw new \InvalidArgumentException($dispatcherResultArrayErrorMessage, __LINE__);
        }
        if (is_null($dispatcherResult) || (is_array($dispatcherResult) && empty($dispatcherResult))) {
            unset($this->DispatcherResult);
        } else {
            $this->DispatcherResult = $dispatcherResult;
        }
        return $this;
    }
    /**
     * Add item to DispatcherResult value
     * @throws \InvalidArgumentException
     * @param \StructType\DispatcherResult $item
     * @return \ArrayType\ArrayOfDispatcherResult
     */
    public function addToDispatcherResult(\StructType\DispatcherResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DispatcherResult) {
            throw new \InvalidArgumentException(sprintf('The DispatcherResult property can only contain items of type \StructType\DispatcherResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DispatcherResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DispatcherResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DispatcherResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DispatcherResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DispatcherResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DispatcherResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DispatcherResult
     */
    public function getAttributeName()
    {
        return 'DispatcherResult';
    }
}
